open Unix;;
open Filename;;

let rec mon_find file =
  let dir_handle = opendir file in
  let rec rec_print_dir () =
    let name = readdir dir_handle in
    if name <> current_dir_name && name <> parent_dir_name then
      begin
        let full_name = (concat file name) in
        print_endline full_name;
        let stat = lstat full_name in
        if stat.st_kind = S_DIR then
          mon_find full_name
      end;
    rec_print_dir ()
  in
  try rec_print_dir ()
  with
  | End_of_file -> closedir dir_handle
  | e -> closedir dir_handle; raise e

let mon_find1 () = mon_find current_dir_name

let () = handle_unix_error mon_find1 ()
